/* 
 * This is a more complicated authenticator. Calls grant_access when successful.
 * The password is kept in the binary as a SHA-1 hash.
 * 
 * We had some problems with the other one. We should enable almost everything
 * now: ASLR, 64bits, NX stack. Moreover, we include libcrypto since people
 * where having trouble installing it properly. Should be super-safe this way.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <openssl/sha.h>

const unsigned char password[] = "\xa6\x1b\x25\x97\x01\x09\x90\xc4\xf8\x71"
                                 "\xb3\x53\xa3\x87\xca\x0e\xd9\xdd\xf2\xc2";

unsigned char *hash;

void grant_access(const unsigned int auth, const unsigned int check) {
    if (auth == 137 && check == 0xdeadbeef)
        printf("Access granted!\n");
    else
        printf("Nice try!\n");
}

void read_password(char *dst) {
    puts("Enter password: ");
    /* OMG! You guys are still using this stupid function?! */
    gets(dst);
}

unsigned int check_password() {
    char buffer[1337];

    hash = malloc(SHA_DIGEST_LENGTH);
    if (hash == NULL) {
        puts("malloc failed");
        exit(EXIT_FAILURE);
    }

    read_password(buffer);

    memset(hash, 0, SHA_DIGEST_LENGTH);
    SHA1((unsigned char *)buffer, 137, hash);

    for (int i = 0; i < SHA_DIGEST_LENGTH; i++)
        if (password[i] != hash[i])
            return 1;

    return 137;
}

int main() {
    grant_access(check_password(), 0xdeadbeef);
}
